## postgresql-9.4 9.4~beta3

=== contrib/dblink/Makefile ===
# contrib/dblink/Makefile

MODULE_big = dblink
OBJS	= dblink.o
PG_CPPFLAGS = -I$(libpq_srcdir)
SHLIB_LINK = $(libpq)
SHLIB_PREREQS = submake-libpq

EXTENSION = dblink
DATA = dblink--1.1.sql dblink--1.0--1.1.sql dblink--unpackaged--1.0.sql

REGRESS = paths dblink
REGRESS_OPTS = --dlpath=$(top_builddir)/src/test/regress
EXTRA_CLEAN = sql/paths.sql expected/paths.out

# the db name is hard-coded in the tests
override USE_MODULE_DB =

ifdef USE_PGXS
PG_CONFIG = pg_config
PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
else
subdir = contrib/dblink
top_builddir = ../..
include $(top_builddir)/src/Makefile.global
include $(top_srcdir)/contrib/contrib-global.mk
endif

=== src/interfaces/libpq/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for src/interfaces/libpq library
#
# Portions Copyright (c) 1996-2014, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# src/interfaces/libpq/Makefile
#
#-------------------------------------------------------------------------

subdir = src/interfaces/libpq
top_builddir = ../../..
include $(top_builddir)/src/Makefile.global


# shared library parameters
NAME= pq
SO_MAJOR_VERSION= 5
SO_MINOR_VERSION= 7

override CPPFLAGS :=  -DFRONTEND -DUNSAFE_STAT_OK -I$(srcdir) $(CPPFLAGS) -I$(top_builddir)/src/port -I$(top_srcdir)/src/port
ifneq ($(PORTNAME), win32)
override CFLAGS += $(PTHREAD_CFLAGS)
endif

# Need to recompile any external C files because we need
# all object files to use the same compile flags as libpq; some
# platforms require special flags.
LIBS := $(LIBS:-lpgport=)

# We can't use Makefile variables here because the MSVC build system scrapes
# OBJS from this file.
OBJS=	fe-auth.o fe-connect.o fe-exec.o fe-misc.o fe-print.o fe-lobj.o \
	fe-protocol2.o fe-protocol3.o pqexpbuffer.o fe-secure.o \
	libpq-events.o
# libpgport C files we always use
OBJS += chklocale.o inet_net_ntop.o noblock.o pgstrcasecmp.o pqsignal.o \
	thread.o
# libpgport C files that are needed if identified by configure
OBJS += $(filter crypt.o getaddrinfo.o getpeereid.o inet_aton.o open.o system.o snprintf.o strerror.o strlcpy.o win32error.o win32setlocale.o, $(LIBOBJS))
# backend/libpq
OBJS += ip.o md5.o
# utils/mb
OBJS += encnames.o wchar.o

ifeq ($(PORTNAME), cygwin)
override shlib = cyg$(NAME)$(DLSUFFIX)
endif

ifeq ($(PORTNAME), win32)
# pgsleep.o is from libpgport
OBJS += pgsleep.o win32.o libpqrc.o

libpqrc.o: libpq.rc
	$(WINDRES) -i $< -o $@

ifeq ($(enable_thread_safety), yes)
OBJS += pthread-win32.o
endif
endif


# Add libraries that libpq depends (or might depend) on into the
# shared library link.  (The order in which you list them here doesn't
# matter.)
ifneq ($(PORTNAME), win32)
SHLIB_LINK += $(filter -lcrypt -ldes -lcom_err -lcrypto -lk5crypto -lkrb5 -lgssapi_krb5 -lgss -lgssapi -lssl -lsocket -lnsl -lresolv -lintl, $(LIBS)) $(LDAP_LIBS_FE) $(PTHREAD_LIBS)
else
SHLIB_LINK += $(filter -lcrypt -ldes -lcom_err -lcrypto -lk5crypto -lkrb5 -lgssapi32 -lssl -lsocket -lnsl -lresolv -lintl $(PTHREAD_LIBS), $(LIBS)) $(LDAP_LIBS_FE)
endif
ifeq ($(PORTNAME), win32)
SHLIB_LINK += -lshfolder -lwsock32 -lws2_32 -lsecur32 $(filter -leay32 -lssleay32 -lcomerr32 -lkrb5_32, $(LIBS))
endif

SHLIB_EXPORTS = exports.txt

all: all-lib

# Shared library stuff
include $(top_srcdir)/src/Makefile.shlib
backend_src = $(top_srcdir)/src/backend


# We use several libpgport and backend modules verbatim, but since we need
# to compile with appropriate options to build a shared lib, we can't
# necessarily use the same object files built for libpgport and the backend.
# Instead, symlink the source files in here and build our own object files.
# For some libpgport modules, this only happens if configure decides
# the module is needed (see filter hack in OBJS, above).

chklocale.c crypt.c getaddrinfo.c getpeereid.c inet_aton.c inet_net_ntop.c noblock.c open.c system.c pgsleep.c pgstrcasecmp.c pqsignal.c snprintf.c strerror.c strlcpy.c thread.c win32error.c win32setlocale.c: % : $(top_srcdir)/src/port/%
	rm -f $@ && $(LN_S) $< .

ip.c md5.c: % : $(backend_src)/libpq/%
	rm -f $@ && $(LN_S) $< .

encnames.c wchar.c: % : $(backend_src)/utils/mb/%
	rm -f $@ && $(LN_S) $< .


distprep: libpq-dist.rc

libpq.rc libpq-dist.rc: libpq.rc.in
	sed -e 's/\(VERSION.*\),0 *$$/\1,'`date '+%y%j' | sed 's/^0*//'`'/' $< >$@

# Depend on Makefile.global to force rebuild on re-run of configure.
# (But libpq-dist.rc is shipped in the distribution for shell-less
# installations and is only updated by distprep.)
libpq.rc: $(top_builddir)/src/Makefile.global

fe-connect.o: fe-connect.c $(top_builddir)/src/port/pg_config_paths.h
fe-misc.o: fe-misc.c $(top_builddir)/src/port/pg_config_paths.h

$(top_builddir)/src/port/pg_config_paths.h:
	$(MAKE) -C $(top_builddir)/src/port pg_config_paths.h

install: all installdirs install-lib
	$(INSTALL_DATA) $(srcdir)/libpq-fe.h '$(DESTDIR)$(includedir)'
	$(INSTALL_DATA) $(srcdir)/libpq-events.h '$(DESTDIR)$(includedir)'
	$(INSTALL_DATA) $(srcdir)/libpq-int.h '$(DESTDIR)$(includedir_internal)'
	$(INSTALL_DATA) $(srcdir)/pqexpbuffer.h '$(DESTDIR)$(includedir_internal)'
	$(INSTALL_DATA) $(srcdir)/pg_service.conf.sample '$(DESTDIR)$(datadir)/pg_service.conf.sample'
ifneq (,$(findstring $(PORTNAME), win32 cygwin))
	$(INSTALL_SHLIB) $(shlib) '$(DESTDIR)$(bindir)/$(shlib)'
endif

installcheck:
	$(MAKE) -C test $@

installdirs: installdirs-lib
	$(MKDIR_P) '$(DESTDIR)$(includedir)' '$(DESTDIR)$(includedir_internal)' '$(DESTDIR)$(datadir)'
ifneq (,$(findstring $(PORTNAME), win32 cygwin))
	$(MKDIR_P) '$(DESTDIR)$(bindir)'
endif

uninstall: uninstall-lib
	rm -f '$(DESTDIR)$(includedir)/libpq-fe.h'
	rm -f '$(DESTDIR)$(includedir)/libpq-events.h'
	rm -f '$(DESTDIR)$(includedir_internal)/libpq-int.h'
	rm -f '$(DESTDIR)$(includedir_internal)/pqexpbuffer.h'
	rm -f '$(DESTDIR)$(datadir)/pg_service.conf.sample'
ifneq (,$(findstring $(PORTNAME), win32 cygwin))
	rm -f '$(DESTDIR)$(bindir)/$(shlib)'
endif

clean distclean: clean-lib
	$(MAKE) -C test $@
	rm -f $(OBJS) pthread.h libpq.rc
# Might be left over from a Win32 client-only build
	rm -f pg_config_paths.h
	rm -f inet_net_ntop.c noblock.c pgstrcasecmp.c pqsignal.c thread.c
	rm -f chklocale.c crypt.c getaddrinfo.c getpeereid.c inet_aton.c open.c system.c snprintf.c strerror.c strlcpy.c win32error.c win32setlocale.c
	rm -f pgsleep.c
	rm -f md5.c ip.c
	rm -f encnames.c wchar.c

maintainer-clean: distclean maintainer-clean-lib
	$(MAKE) -C test $@
	rm -f libpq-dist.rc

## postgresql-9.4 9.4~20140428.1601

=== debian/changelog ===
postgresql-9.4 (9.4~20140428.1601-1~81.bzrd272244.pgdg+1) sid-pgdg; urgency=low

  * Rebuild for sid-pgdg (jenkins-postgresql-9.4-source-
    distribution=sid-81, bzr revision
    d2722443d993988ff2e529b652c61fec1ca527f7)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Mon, 28 Apr 2014 18:01:55 +0200

postgresql-9.4 (9.4~~devel-1) UNRELEASED; urgency=low

  * Update for 9.4. Packaging based on 9.3 branch.

 -- Christoph Berg <myon@debian.org>  Sun, 23 Mar 2014 17:02:48 +0100

=== debian/control ===
Source: postgresql-9.4
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
Uploaders: Martin Pitt <mpitt@debian.org>, Peter Eisentraut <petere@debian.org>, Christoph Berg <myon@debian.org>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 8~),
 dpkg-dev (>= 1.16.1~) | hardening-wrapper,
 perl (>= 5.8),
 libperl-dev,
 tcl8.6-dev | tcl8.5-dev,
 libedit-dev,
 libssl-dev,
 zlib1g-dev | libz-dev,
 libpam0g-dev | libpam-dev,
 libxml2-dev,
 krb5-multidev,
 libldap2-dev,
 libxslt1-dev,
 libossp-uuid-dev,
 python-dev,
 python3-dev,
 bison,
 flex,
 openjade,
 docbook-dsssl,
 docbook-xsl,
 docbook,
 opensp,
 xsltproc,
 gettext
Homepage: http://www.postgresql.org/
Vcs-Browser: http://anonscm.debian.org/loggerhead/pkg-postgresql/postgresql-9.4/trunk
Vcs-Bzr: http://bzr.debian.org/bzr/pkg-postgresql/postgresql-9.4/trunk/
XS-Testsuite: autopkgtest

Package: libpq-dev
Architecture: any
Section: 9.4/libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq5 (= ${binary:Version}),
 libssl-dev,
 krb5-multidev,
 comerr-dev
Suggests: postgresql-doc-9.4
Description: header files for libpq5 (PostgreSQL library)
 Header files and static library for compiling C programs to link
 with the libpq library in order to communicate with a PostgreSQL
 database backend.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpq5
Architecture: any
Section: 9.4/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: PostgreSQL C client library
 libpq is a C library that enables user programs to communicate with
 the PostgreSQL database server.  The server can be on another machine
 and accessed through TCP/IP.  This version of libpq is compatible
 with servers from PostgreSQL 8.2 or later.
 .
 This package contains the run-time library, needed by packages using
 libpq.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg6
Architecture: any
Section: 9.4/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: run-time library for ECPG programs
 The libecpg shared library is used by programs built with ECPG
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg-dev
Architecture: any
Section: 9.4/libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev,
 libecpg6 (= ${binary:Version}),
 libecpg-compat3 (= ${binary:Version}),
 libpgtypes3 (= ${binary:Version})
Description: development files for ECPG (Embedded PostgreSQL for C)
 This package contains the necessary files to build ECPG (Embedded
 PostgreSQL for C) programs.  It includes the development libraries
 and the preprocessor program ecpg.
 .
 PostgreSQL is an object-relational SQL database management system.
 .
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

Package: libecpg-compat3
Architecture: any
Section: 9.4/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: older version of run-time library for ECPG programs
 The libecpg_compat shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpgtypes3
Architecture: any
Section: 9.4/libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared library libpgtypes for PostgreSQL 9.4
 The libpgtypes shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-9.4
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgresql-client-9.4,
 postgresql-common (>= 142~),
 tzdata,
 ssl-cert,
 locales
Suggests: oidentd | ident-server, locales-all
Description: object-relational SQL database, version 9.4 server
 PostgreSQL is a fully featured object-relational database management
 system.  It supports a large part of the SQL standard and is designed
 to be extensible by users in many aspects.  Some of the features are:
 ACID transactions, foreign keys, views, sequences, subqueries,
 triggers, user-defined types and functions, outer joins, multiversion
 concurrency control.  Graphical user interfaces and bindings for many
 programming languages are available as well.
 .
 This package provides the database server for PostgreSQL 9.4. Servers
 for other major release versions can be installed simultaneously and
 are coordinated by the postgresql-common package. A package providing
 ident-server is needed if you want to authenticate remote connections
 with identd.

Package: postgresql-9.4-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends}, postgresql-9.4 (= ${binary:Version})
Provides: postgresql-dbg
Description: debug symbols for postgresql-9.4
 PostgreSQL is a fully featured object-relational database management
 system.  It supports a large part of the SQL standard and is designed
 to be extensible by users in many aspects.  Some of the features are:
 ACID transactions, foreign keys, views, sequences, subqueries,
 triggers, user-defined types and functions, outer joins, multiversion
 concurrency control.  Graphical user interfaces and bindings for many
 programming languages are available as well.
 .
 This package provides detached debugging symbols for PostgreSQL 9.4.

Package: postgresql-client-9.4
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq5 (>= ${source:Upstream-Version}),
 postgresql-client-common (>= 142~)
Suggests: postgresql-9.4, postgresql-doc-9.4
Provides: postgresql-client
Description: front-end programs for PostgreSQL 9.4
 This package contains client and administrative programs for
 PostgreSQL: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for PostgreSQL 9.4. If you install
 PostgreSQL 9.4 on a standalone machine, you need the server package
 postgresql-9.4, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-server-dev-9.4
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 ${shlibs:Depends},
 libpq-dev (>= 9.4~),
 postgresql-common (>= 142~)
Description: development files for PostgreSQL 9.4 server-side programming
 Header files for compiling SSI code to link into PostgreSQL's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on
 modules of PostgreSQL, which would otherwise have to be built in the
 PostgreSQL source-code tree.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-doc-9.4
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: documentation for the PostgreSQL database management system
 This package contains all README files, user manual, and examples for
 PostgreSQL 9.4. The manual is in HTML format.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-contrib-9.4
Architecture: any
Depends: postgresql-9.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests: libdbd-pg-perl
Description: additional facilities for PostgreSQL
 The PostgreSQL contrib package provides several additional features
 for the PostgreSQL database. This version is built to work with the
 server package postgresql-9.4.  contrib often serves as a testbed for
 features before they are adopted into PostgreSQL proper:
 .
  adminpack      - File and log manipulation routines, used by pgAdmin
  btree_gist     - B-Tree indexing using GiST (Generalised Search Tree)
  chkpass        - An auto-encrypted password datatype
  cube           - Multidimensional-cube datatype (GiST indexing example)
  dblink         - Functions to return results from a remote database
  earthdistance  - Operator for computing the distance (in miles) between
                   two points on the earth's surface
  fuzzystrmatch  - Levenshtein, metaphone, and soundex fuzzy string matching
  hstore         - Store (key, value) pairs
  intagg         - Integer aggregator/enumerator
  _int           - Index support for arrays of int4, using GiST (benchmark
                   needs the libdbd-pg-perl package)
  isn            - type extensions for ISBN, ISSN, ISMN, EAN13 product numbers
  lo             - Large Object maintenance
  ltree          - Tree-like data structures
  oid2name       - Maps OIDs to table names
  pageinspect    - Inspection of database pages
  passwordcheck  - Simple password strength checker
  pg_buffercache - Real time queries on the shared buffer cache
  pg_freespacemap- Displays the contents of the free space map (FSM)
  pg_trgm        - Determine the similarity of text based on trigram matching
  pg_standby     - Create a warm stand-by server
  pgbench        - TPC-B like benchmark
  pgcrypto       - Cryptographic functions
  pgrowlocks     - A function to return row locking information
  pgstattuple    - Returns the percentage of dead tuples in a table; this
                   indicates whether a vacuum is required.
  postgresql_fwd - foreign data wrapper for PostgreSQL
  seg            - Confidence-interval datatype (GiST indexing example)
  spi            - PostgreSQL Server Programming Interface; 4 examples of
                   its use:
                   autoinc    - A function for implementing AUTOINCREMENT/
                                IDENTITY
                   insert_username - function for inserting user names
                   moddatetime - Update modification timestamps
                   refint     - Functions for implementing referential
                                integrity (foreign keys).  Note that this is
                                now superseded by built-in referential
                                integrity.
                   timetravel - Re-implements in user code the time travel
                                feature that was removed in 6.3.
  tablefunc      - examples of functions returning tables
  uuid-ossp      - UUID generation functions
  vacuumlo       - Remove orphaned large objects
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plperl-9.4
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgresql-9.4 (= ${binary:Version}),
 perl
Provides: postgresql-plperl
Description: PL/Perl procedural language for PostgreSQL 9.4
 PL/Perl enables an SQL developer to write procedural language functions
 for PostgreSQL 9.4 in Perl.  You need this package if you have any
 PostgreSQL 9.4 functions that use the languages plperl or plperlu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plpython-9.4
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgresql-9.4 (= ${binary:Version})
Provides: postgresql-plpython
Description: PL/Python procedural language for PostgreSQL 9.4
 PL/Python enables an SQL developer to write procedural language functions
 for PostgreSQL 9.4 in Python.  You need this package if you have any
 PostgreSQL 9.4 functions that use the languages plpython or plpythonu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plpython3-9.4
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 postgresql-9.4 (= ${binary:Version})
Provides: postgresql-plpython3
Description: PL/Python 3 procedural language for PostgreSQL 9.4
 PL/Python 3 enables an SQL developer to write procedural language functions
 for PostgreSQL 9.4 in Python 3.  You need this package if you have any
 PostgreSQL 9.4 functions that use the languages plpython3 or plpython3u.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-pltcl-9.4

=== debian/rules ===
#!/usr/bin/make -f
ifneq ($(shell which tclsh8.6),)
TCL_VER := 8.6
else
TCL_VER := 8.5
endif
MAJOR_VER := 9.4

DEB_BUILD_ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# this must also work for old releases with multiarch, so don't fail if the
# variable doesn't exist
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH || true)

# support multi-arch location
ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/tcl$(TCL_VER)),)
TCL_CONFIG_DIR := /usr/lib/$(DEB_HOST_MULTIARCH)
else
TCL_CONFIG_DIR := /usr/lib
endif

# support both hardening-wrapper (for backports) and dpkg-buildflags
export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
LDFLAGS+= -Wl,--as-needed -L/usr/lib/mit-krb5 -L/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5
CFLAGS+= -fPIC -pie -I/usr/include/mit-krb5

# When protecting the postmaster with oom_adj=-17, allow the OOM killer to slay
# the backends (http://archives.postgresql.org/pgsql-hackers/2010-01/msg00170.php)
ifeq ($(shell uname -s),Linux)
CFLAGS+= -DLINUX_OOM_SCORE_ADJ=0
endif

# sparc and alpha's gcc used to miscompile; see
# http://lists.debian.org/debian-alpha/2007/11/msg00025.html
#ifneq ($(findstring $(DEB_BUILD_ARCH), sparc alpha),)
#    CFLAGS+=-O1
#endif

# Facilitate hierarchical profile generation on amd64 (#730134)
ifeq ($(shell dpkg-architecture -qDEB_BUILD_ARCH),amd64)
CFLAGS+= -fno-omit-frame-pointer
endif

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

COMMON_CONFIGURE_FLAGS= \
  --mandir=/usr/share/postgresql/$(MAJOR_VER)/man \
  --docdir=/usr/share/doc/postgresql-doc-$(MAJOR_VER) \
  --sysconfdir=/etc/postgresql-common \
  --datarootdir=/usr/share/ \
  --datadir=/usr/share/postgresql/$(MAJOR_VER) \
  --bindir=/usr/lib/postgresql/$(MAJOR_VER)/bin \
  --libdir=/usr/lib/ \
  --libexecdir=/usr/lib/postgresql/ \
  --includedir=/usr/include/postgresql/ \
  --enable-nls \
  --enable-integer-datetimes \
  --enable-thread-safety \
  --enable-debug \
  --disable-rpath \
  --with-ossp-uuid \
  --with-gnu-ld \
  --with-pgport=5432 \
  --with-system-tzdata=/usr/share/zoneinfo \
  CFLAGS='$(CFLAGS)' \
  LDFLAGS='$(LDFLAGS)'

# allow missing krb5 and ldap during bootstrapping
ifeq ($(DEB_STAGE),stage1)
BOOTSTRAP_FLAGS=
else
BOOTSTRAP_FLAGS= --with-krb5 --with-gssapi --with-ldap
endif

# build should fail on test suite failures on all arches
TESTSUITE_FAIL_CMD=exit 1
# hurd doesn't implement semaphores; succeed anyway so they at least have libpq5
# plperl currently fails on kfreebsd-*
ifneq ($(filter $(DEB_BUILD_ARCH), hurd-i386 kfreebsd-amd64 kfreebsd-i386),)
TESTSUITE_FAIL_CMD=exit 0
endif

%:
	dh $@ --parallel

override_dh_auto_configure: stamp/configure-build stamp/configure-build-py3

stamp/configure-build:
	mkdir -p stamp build
	cd build && ../configure \
           --with-tcl \
           --with-perl \
           --with-python \
           --with-pam \
           --with-openssl \
           --with-libxml \
           --with-libxslt \
           --with-tclconfig=$(TCL_CONFIG_DIR)/tcl$(TCL_VER) \
           --with-includes=/usr/include/tcl$(TCL_VER) \
           PYTHON=/usr/bin/python \
           $(COMMON_CONFIGURE_FLAGS) \
           $(BOOTSTRAP_FLAGS)
	touch "$@"
	
stamp/configure-build-py3:
	mkdir build-py3
	cd build-py3 && ../configure \
           --with-python \
           PYTHON=/usr/bin/python3 \
           $(COMMON_CONFIGURE_FLAGS)
	touch "$@"

override_dh_auto_build: stamp/build stamp/build-py3

stamp/build: stamp/configure-build
	cd build && $(MAKE) world

	# generate POT files for translators
	find -name nls.mk -exec sh -c "make -C \$$(dirname {}) init-po" \;

	# build tutorial stuff
	make -C build/src/tutorial NO_PGXS=1

	touch "$@"

stamp/build-py3: stamp/configure-build-py3
	cd build-py3 && $(MAKE) -C src/backend/ submake-errcodes && $(MAKE) -C src/pl/plpython
	touch "$@"

override_dh_auto_install:
	make -C build-py3/src/pl/plpython install DESTDIR=$(CURDIR)/debian/tmp
	make -C build install-world DESTDIR=$(CURDIR)/debian/tmp
	# compress manpages
	gzip -9n $(CURDIR)/debian/tmp/usr/share/postgresql/*/man/man*/*.[137]

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/postgresql/$(MAJOR_VER)

override_dh_auto_clean:
	rm -rf build* stamp contrib/file_fdw/sql/file_fdw.sql

override_dh_installchangelogs:
	dh_installchangelogs HISTORY

override_dh_compress:
	dh_compress -X.source -X.c

override_dh_install:
	dh_install --fail-missing

	# these get installed into the individual -/l* packages; -f because it
	# does not exist for an -A build
	rm -f debian/postgresql-contrib-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/extension/pl*

	if [ -d debian/postgresql-doc-$(MAJOR_VER) ]; then \
		install src/tutorial/*.c src/tutorial/*.source src/tutorial/Makefile src/tutorial/README debian/postgresql-doc-$(MAJOR_VER)/usr/share/doc/postgresql-doc-$(MAJOR_VER)/tutorial; \
	fi

override_dh_auto_test:
ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	# when tests fail, print all regression.diffs files, as well as the newest log files
	if ! $(MAKE) -C build check-world EXTRA_REGRESS_OPTS='--host=/tmp --port=$(shell perl -le 'print 1024 + int(rand(64000))')'; then \
	    for l in `find build -name regression.diffs -o -mmin 0 \( -name initdb.log -o -name postmaster.log \)`; do \
		echo "******** $$l ********"; \
		tail -n100 $$l; \
	    done; \
	    $(TESTSUITE_FAIL_CMD); \
	fi
endif

override_dh_strip:
	dh_strip --dbg-package=postgresql-$(MAJOR_VER)-dbg

override_dh_builddeb:
	dh_builddeb -- -Zxz

## postgresql-9.4 9.4~beta2

=== debian/changelog ===
postgresql-9.4 (9.4~beta2-1b1) staging; urgency=medium

  * No-change rebuild against Perl 5.20

 -- Tanglu AutoRebuilder <dak-rebuild@ftp-master.tanglu.org>  Wed, 20 Aug 2014 22:33:13 +0200

postgresql-9.4 (9.4~beta2-1) unstable; urgency=low

  * New upstream beta version.
    + Secure Unix-domain sockets of temporary postmasters started during make
      check (Noah Misch)

      Any local user able to access the socket file could connect as the
      server's bootstrap superuser, then proceed to execute arbitrary code as
      the operating-system user running the test, as we previously noted in
      CVE-2014-0067. This change defends against that risk by placing the
      server's socket in a temporary, mode 0700 subdirectory of /tmp.

  * postgresql-9.4.preinst: Fail upgrade when upgrading from beta1, the
    catalog version changed. People should dump/remove their old clusters
    first.
  * Use util-linux' uuid lib as backend for the uuid-ossp extension
    (--with-uuid=e2fs).
  * Enable sepgsql (--with-selinux). On systems with libselinux1-dev < 2.1.10,
    this is automatically disabled.
  * Revert multiarch for libpq-dev and libecpg-dev. (Closes: #750111, #750112)
  * Remove our pg_regress patches to support --host=/path. Implemented
    upstream as fix for CVE-2014-0067.
  * debian/copyright: Say that there are various copyright holders for the
    contrib modules. (Hello Lintian!)
  * Update Vcs URLs.

 -- Christoph Berg <myon@debian.org>  Mon, 21 Jul 2014 22:26:24 +0200

postgresql-9.4 (9.4~beta1-2) experimental; urgency=medium

  * Update watch file for 9.4.
  * Enable multiarch support in libpq and friends. (Closes: #706849)
    Support is automatically disabled when the distribution does not support
    it.
  * Stop providing postgresql-dbg in postgresql-9.4-dbg. Its only purpose was
    to conflict with other postgresql-*-dbg packages, and that's no longer
    needed with build-id debug symbols.
  * Skip -pie on 32bit archs for performance and stability reasons.
    Closes: #749686; details at
    http://www.postgresql.org/message-id/20140519115318.GB7296@msgid.df7cb.de
  * Update contrib copyright statements, and move them to a separate file.
    Thanks to Thorsten Alteholz for reviewing the package.

 -- Christoph Berg <myon@debian.org>  Fri, 30 May 2014 20:09:50 +0200

postgresql-9.4 (9.4~beta1-1) experimental; urgency=low

  * Update for 9.4. Packaging based on 9.3 branch.
  * Bump to debhelper 9 to get debug symbol files based on build-ids.

 -- Christoph Berg <myon@debian.org>  Mon, 12 May 2014 22:08:37 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
 Uploaders: Martin Pitt <mpitt@debian.org>, Peter Eisentraut <petere@debian.org>, Christoph Berg <myon@debian.org>
 Standards-Version: 3.9.5
-Build-Depends: debhelper (>= 8~),
+Build-Depends: debhelper (>= 9~),
  dpkg-dev (>= 1.16.1~) | hardening-wrapper,
  perl (>= 5.8),
  libperl-dev,
@@ -16,8 +16,9 @@
  libxml2-dev,
  krb5-multidev,
  libldap2-dev,
+ libselinux1-dev [linux-any],
  libxslt1-dev,
- libossp-uuid-dev,
+ uuid-dev,
  python-dev,
  python3-dev,
  bison,
@@ -30,13 +31,13 @@
  xsltproc,
  gettext
 Homepage: http://www.postgresql.org/
-Vcs-Browser: http://anonscm.debian.org/loggerhead/pkg-postgresql/postgresql-9.4/trunk
-Vcs-Bzr: http://bzr.debian.org/bzr/pkg-postgresql/postgresql-9.4/trunk/
+Vcs-Browser: https://alioth.debian.org/scm/loggerhead/pkg-postgresql/postgresql-9.4/trunk/changes
+Vcs-Bzr: http://anonscm.debian.org/bzr/pkg-postgresql/postgresql-9.4/trunk/
 XS-Testsuite: autopkgtest
 
 Package: libpq-dev
 Architecture: any
-Section: 9.4/libdevel
+Section: libdevel
 Depends: ${misc:Depends},
  ${shlibs:Depends},
  libpq5 (= ${binary:Version}),
@@ -53,8 +54,10 @@
 
 Package: libpq5
 Architecture: any
-Section: 9.4/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: ${misc:Multi-Arch}
 Description: PostgreSQL C client library
  libpq is a C library that enables user programs to communicate with
  the PostgreSQL database server.  The server can be on another machine
@@ -68,8 +71,10 @@
 
 Package: libecpg6
 Architecture: any
-Section: 9.4/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: ${misc:Multi-Arch}
 Description: run-time library for ECPG programs
  The libecpg shared library is used by programs built with ECPG
  (Embedded PostgreSQL for C).
@@ -78,7 +83,7 @@
 
 Package: libecpg-dev
 Architecture: any
-Section: 9.4/libdevel
+Section: libdevel
 Depends: ${misc:Depends},
  ${shlibs:Depends},
  libpq-dev,
@@ -97,8 +102,10 @@
 
 Package: libecpg-compat3
 Architecture: any
-Section: 9.4/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: ${misc:Multi-Arch}
 Description: older version of run-time library for ECPG programs
  The libecpg_compat shared library is used by programs built with ecpg.
  (Embedded PostgreSQL for C).
@@ -107,8 +114,10 @@
 
 Package: libpgtypes3
 Architecture: any
-Section: 9.4/libs
+Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: ${misc:Multi-Arch}
 Description: shared library libpgtypes for PostgreSQL 9.4
  The libpgtypes shared library is used by programs built with ecpg.
  (Embedded PostgreSQL for C).
@@ -145,7 +154,6 @@
 Priority: extra
 Architecture: any
 Depends: ${misc:Depends}, postgresql-9.4 (= ${binary:Version})
-Provides: postgresql-dbg
 Description: debug symbols for postgresql-9.4
  PostgreSQL is a fully featured object-relational database management
  system.  It supports a large part of the SQL standard and is designed
@@ -246,6 +254,7 @@
                    indicates whether a vacuum is required.
   postgresql_fwd - foreign data wrapper for PostgreSQL
   seg            - Confidence-interval datatype (GiST indexing example)
+  sepgsql        - mandatory access control (MAC) based on SELinux
   spi            - PostgreSQL Server Programming Interface; 4 examples of
                    its use:
                    autoinc    - A function for implementing AUTOINCREMENT/
@@ -298,10 +307,3 @@
  postgresql-9.4 (= ${binary:Version})
 Provides: postgresql-plpython3
 Description: PL/Python 3 procedural language for PostgreSQL 9.4
- PL/Python 3 enables an SQL developer to write procedural language functions
- for PostgreSQL 9.4 in Python 3.  You need this package if you have any
- PostgreSQL 9.4 functions that use the languages plpython3 or plpython3u.
- .
- PostgreSQL is an object-relational SQL database management system.
-
-Package: postgresql-pltcl-9.4

## postgresql-9.4 9.4~beta3

=== debian/changelog ===
postgresql-9.4 (9.4~beta3-2) unstable; urgency=medium

  * postgresql-9.4.preinst: Output detailed dump-reload instructions when
    refusing the package upgrade, and also add a NEWS item about it.
    (Closes: #764705)
  * Add libipc-run-perl for the regression tests which otherwise skip large
    parts.
  * Update Standards-Version.

 -- Christoph Berg <myon@debian.org>  Wed, 15 Oct 2014 19:44:43 +0200

postgresql-9.4 (9.4~beta3-1) unstable; urgency=medium

  * New upstream beta version.
    + Catalog version number changed, older 9.4 clusters need to be dumped and
      reloaded.
    + Regexp regression fixed. (Closes: #760564)
    + CACHE_LINE_SIZE definition renamed to mitigate conflict on *BSD.
      (Closes: #763098)

  [ Martin Pitt ]
  * Add missing logrotate test dependency.

  [ Christoph Berg ]
  * Set Multi-Arch: foreign in postgresql-client-9.4 and postgresql-doc-9.4.
    (Closes: #757520; do it even on non-multiarch dists, it doesn't hurt.)
  * Fix postgresql_fdw in description, spotted by Zack Weinberg, thanks!
    (Closes: #762389)

 -- Christoph Berg <myon@debian.org>  Tue, 07 Oct 2014 20:39:57 +0200

## postgresql-9.4 9.4.1

=== debian/changelog ===
postgresql-9.4 (9.4.1-1) unstable; urgency=medium

  * New upstream version.
    + libpq5: Name lookups fixed in minimal chroots (Closes: #756627)
    + Fix buffer overruns in to_char() (CVE-2015-0241)
    + Fix buffer overruns in contrib/pgcrypto (CVE-2015-0243)
    + Fix possible loss of frontend/backend protocol synchronization after an
      error (CVE-2015-0244)
    + Fix information leak via constraint-violation error messages
      (CVE-2014-8161)

 -- Christoph Berg <myon@debian.org>  Wed, 04 Feb 2015 17:55:28 +0100

postgresql-9.4 (9.4.0-1) unstable; urgency=medium

  * 9.4 released.
  * libpq5.symbols: PQhostaddr removed; it was new in 9.4.

 -- Christoph Berg <myon@debian.org>  Wed, 17 Dec 2014 22:21:22 +0100

postgresql-9.4 (9.4~rc1-1) unstable; urgency=medium

  * First 9.4 RC release.
  * Update psql call in dump-reload instructions.
  * Reenable 010_pg_basebackup.t tests, fixed upstream.

 -- Christoph Berg <myon@debian.org>  Tue, 18 Nov 2014 09:49:04 +0100

postgresql-9.4 (9.4~beta3-3) unstable; urgency=medium

  * Temporarily disable failing test in 010_pg_basebackup.t.

 -- Christoph Berg <myon@debian.org>  Thu, 16 Oct 2014 09:32:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
 Uploaders: Martin Pitt <mpitt@debian.org>, Peter Eisentraut <petere@debian.org>, Christoph Berg <myon@debian.org>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9~),
  dpkg-dev (>= 1.16.1~) | hardening-wrapper,
  perl (>= 5.8),
  libperl-dev,
+ libipc-run-perl,
  tcl8.6-dev | tcl8.5-dev,
  libedit-dev,
  libssl-dev,
@@ -167,6 +168,7 @@
 
 Package: postgresql-client-9.4
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends},
  ${shlibs:Depends},
  libpq5 (>= ${source:Upstream-Version}),
@@ -205,6 +207,7 @@
 
 Package: postgresql-doc-9.4
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Description: documentation for the PostgreSQL database management system
@@ -252,7 +255,7 @@
   pgrowlocks     - A function to return row locking information
   pgstattuple    - Returns the percentage of dead tuples in a table; this
                    indicates whether a vacuum is required.
-  postgresql_fwd - foreign data wrapper for PostgreSQL
+  postgresql_fdw - foreign data wrapper for PostgreSQL
   seg            - Confidence-interval datatype (GiST indexing example)
   sepgsql        - mandatory access control (MAC) based on SELinux
   spi            - PostgreSQL Server Programming Interface; 4 examples of
@@ -306,4 +309,3 @@
  ${shlibs:Depends},
  postgresql-9.4 (= ${binary:Version})
 Provides: postgresql-plpython3
-Description: PL/Python 3 procedural language for PostgreSQL 9.4

## postgresql-9.4 9.4.2

=== debian/changelog ===
postgresql-9.4 (9.4.2-0+deb8u1~tanglu1.1) bartholomea-updates; urgency=medium

  * No-change merge from Debian for Tanglu because of security issue DSA 3270-1

 -- Thomas Funk <t.funk@web.de>  Sat, 23 May 2015 21:54:54 +0200

postgresql-9.4 (9.4.2-0+deb8u1) stable-security; urgency=medium

  * New upstream version.

    + Avoid possible crash when client disconnects just before the
      authentication timeout expires (Benkocs Norbert Attila)

      If the timeout interrupt fired partway through the session shutdown
      sequence, SSL-related state would be freed twice, typically causing a
      crash and hence denial of service to other sessions.  Experimentation
      shows that an unauthenticated remote attacker could trigger the bug
      somewhat consistently, hence treat as security issue. (CVE-2015-3165)

    + Improve detection of system-call failures (Noah Misch)

      Our replacement implementation of snprintf() failed to check for errors
      reported by the underlying system library calls; the main case that
      might be missed is out-of-memory situations. In the worst case this
      might lead to information exposure, due to our code assuming that a
      buffer had been overwritten when it hadn't been. Also, there were a few
      places in which security-relevant calls of other system library
      functions did not check for failure.

      It remains possible that some calls of the *printf() family of functions
      are vulnerable to information disclosure if an out-of-memory error
      occurs at just the wrong time.  We judge the risk to not be large, but
      will continue analysis in this area. (CVE-2015-3166)

    + In contrib/pgcrypto, uniformly report decryption failures as Wrong key
      or corrupt data (Noah Misch)

      Previously, some cases of decryption with an incorrect key could report
      other error message texts.  It has been shown that such variance in
      error reports can aid attackers in recovering keys from other systems.
      While it's unknown whether pgcrypto's specific behaviors are likewise
      exploitable, it seems better to avoid the risk by using a
      one-size-fits-all message. (CVE-2015-3167)

    + Protect against wraparound of multixact member IDs
      (Álvaro Herrera, Robert Haas, Thomas Munro)

      Under certain usage patterns, the existing defenses against this might
      be insufficient, allowing pg_multixact/members files to be removed too
      early, resulting in data loss.
      The fix for this includes modifying the server to fail transactions that
      would result in overwriting old multixact member ID data, and improving
      autovacuum to ensure it will act proactively to prevent multixact member
      ID wraparound, as it does for transaction ID wraparound.

  * Repository moved to git, update Vcs headers.

 -- Christoph Berg <christoph.berg@credativ.de>  Thu, 21 May 2015 15:58:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: postgresql-9.4
 Section: database
 Priority: optional
-Maintainer: Debian PostgreSQL Maintainers <pkg-postgresql-public@lists.alioth.debian.org>
+Maintainer: Tanglu Developers <tanglu-devel-discuss@lists.tanglu.org>
 Uploaders: Martin Pitt <mpitt@debian.org>, Peter Eisentraut <petere@debian.org>, Christoph Berg <myon@debian.org>
 Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9~),
@@ -32,8 +32,8 @@
  xsltproc,
  gettext
 Homepage: http://www.postgresql.org/
-Vcs-Browser: https://alioth.debian.org/scm/loggerhead/pkg-postgresql/postgresql-9.4/trunk/changes
-Vcs-Bzr: http://anonscm.debian.org/bzr/pkg-postgresql/postgresql-9.4/trunk/
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-postgresql/postgresql.git/
+Vcs-Git: https://anonscm.debian.org/git/pkg-postgresql/postgresql.git -b 9.4-jessie
 XS-Testsuite: autopkgtest
 
 Package: libpq-dev
